diff --git a/src/detection-plugins/sp_sctp_chunk_flags.c b/src/detection-plugins/sp_sctp_chunk_flags.c
new file mode 100644
index 0000000..4e7f57f
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_chunk_flags.c
@@ -0,0 +1,464 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <sys/types.h>
+#include <stdlib.h>
+#include <ctype.h>
+
+#include "sf_types.h"
+#include "rules.h"
+#include "treenodes.h"
+#include "decode.h"
+#include "plugbase.h"
+#include "parser.h"
+#include "util.h"
+#include "snort_debug.h"
+#include "plugin_enum.h"
+#include "sp_sctp_chunk_flags.h"
+#include "sp_sctp_chunk_type.h"
+
+#include "snort.h"
+#include "profiler.h"
+#ifdef PERF_PROFILING
+PreprocStats sctpChunkFlagsPerfStats;
+extern PreprocStats ruleOTNEvalPerfStats;
+#endif
+
+#include "sfhashfcn.h"
+#include "detection_options.h"
+
+
+/**
+ * SctpChunkFlagsHash - Hash function for sctp_chunk_flags.
+ * @data: pointer to SctpChunkFlagsData.
+ *
+ * Returns a uint32_t representing the hash.
+ */
+uint32_t SctpChunkFlagsHash(void *data)
+{
+    uint32_t a, b, c;
+    SctpChunkFlagsData *scfd = (SctpChunkFlagsData *)data;
+
+    a = scfd->mode;
+    b = scfd->flags || (scfd->mask << 8);
+    c = RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS;
+    final(a, b, c);
+
+    return c;
+}
+
+/**
+ * SctpChunkFlagsCompare - Comparator function for sctp_chunk_flags.
+ * @l: pointer to SctpChunkFlagsData (left side).
+ * @r: pointer to SctpChunkFlagsData (right side).
+ *
+ * Returns the comparison result of the two data structures.
+ */
+int SctpChunkFlagsCompare(void *l, void *r)
+{
+    SctpChunkFlagsData *left = (SctpChunkFlagsData *)l;
+    SctpChunkFlagsData *right = (SctpChunkFlagsData *)r;
+
+    if (!left)
+        return (!right ? DETECTION_OPTION_EQUAL : 
+                         DETECTION_OPTION_NOT_EQUAL);
+    
+    if (!right)
+        return (!left ? DETECTION_OPTION_EQUAL : 
+                        DETECTION_OPTION_NOT_EQUAL);
+
+    if (left->mode != right->mode)   return DETECTION_OPTION_NOT_EQUAL;
+    if (left->flags != right->flags) return DETECTION_OPTION_NOT_EQUAL;
+    if (left->mask != right->mask)   return DETECTION_OPTION_NOT_EQUAL;
+
+    return DETECTION_OPTION_EQUAL;
+}
+
+/**
+ * SctpChunkFlagsSetup - Setup function for sctp_chunk_flags.
+ *
+ * Links the 'sctp_chunk_flags' keyword to its initialization function.
+ * Returns void.
+ */
+void SctpChunkFlagsSetup(void)
+{
+    /* Map the keyword to an initialization/processing function */
+    RegisterRuleOption("sctp_chunk_flags", SctpChunkFlagsInit, NULL, OPT_TYPE_DETECTION, NULL);
+    
+#ifdef PERF_PROFILING
+    RegisterPreprocessorProfile("sctp_chunk_flags", &sctpChunkFlagsPerfStats, 3, &ruleOTNEvalPerfStats);
+#endif
+
+    DEBUG_WRAP(DebugMessage(DEBUG_PLUGIN,"Plugin: SctpChunkFlags Initialized\n"););
+}
+
+/**
+ * SctpChunkFlagsInit - Initialization function for sctp_chunk_flags.
+ * @data: pointer to SctpChunkFlagsData (as char *).
+ * @otn: pointer to OptTreeNode structure.
+ * @protocol: integer value representing the transport-layer protocol.
+ *
+ * Attaches the rule option data to the appropriate data structure and links
+ * in the evaluator function to the function pointer list.  Returns void.
+ */
+void SctpChunkFlagsInit(char *data, OptTreeNode *otn, int protocol)
+{
+    OptFpList *fpl;
+    SctpChunkFlagsData *scfd;
+    void *scfd_dup;
+
+    /* This keyword only applies to the SCTP Protocol. */
+    if (protocol != IPPROTO_SCTP)
+        FatalError("Error at %s:%d: 'sctp_chunk_flags' can only be used with "
+                   "the SCTP protocol.\n", file_name, file_line);
+
+    /* This keyword requires 'sctp_chunk_type' to be used first. */
+    if (otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE] == NULL)
+        FatalError("%s(%d): 'sctp_chunk_type' must be used before "
+                   "'sctp_chunk_flags'.", file_name, file_line);
+
+    /* Check for multiple uses of this keyword in a rule. */
+    if (otn->ds_list[PLUGIN_SCTP_CHUNK_FLAGS])
+        FatalError("%s(%d): 'sctp_chunk_flags' may only be used once per "
+                   "rule.\n", file_name, file_line);
+
+    /* Allocate the data structure and attach it to the otn->ds_list. */
+    otn->ds_list[PLUGIN_SCTP_CHUNK_FLAGS] = (SctpChunkFlagsData *)
+            SnortAlloc(sizeof(SctpChunkFlagsData));
+
+    /* Parse the keyword's parameters and configure the data structure. */
+    SctpChunkFlagsParse(data, otn);
+    scfd = otn->ds_list[PLUGIN_SCTP_CHUNK_FLAGS];
+
+    /* Check for a duplicate entry in the otn. */
+    if (add_detection_option(RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS,
+                             (void *)scfd, &scfd_dup) == DETECTION_OPTION_EQUAL)
+    {
+        otn->ds_list[PLUGIN_SCTP_CHUNK_FLAGS] = (SctpChunkFlagsData *)scfd_dup;
+        free(scfd);
+    }
+
+    /*
+     * Finally, attach the option's detection function to the rule's detection
+     * function pointer list
+     */
+    fpl = AddOptFuncToList(SctpChunkFlagsEval, otn);
+    fpl->type = RULE_OPTION_TYPE_SCTP_CHUNK_FLAGS;
+    fpl->context = otn->ds_list[PLUGIN_SCTP_CHUNK_FLAGS];
+}
+
+/**
+ * SctpChunkFlagsParse - Parsing function for sctp_chunk_flags.
+ * @data: pointer to SctpChunkFlagsData (as char *).
+ * @otn: pointer to OptTreeNode structure.
+ *
+ * Parses the rule option's parameter list and fills in the SctpChunkFlagsData
+ * structure.  Returns void.
+ */
+void SctpChunkFlagsParse(char *data, OptTreeNode *otn)
+{
+    char *params, *end = NULL;
+    uint32_t comma_set = 0;
+    SctpChunkTypeData *sctd;
+    SctpChunkFlagsData *scfd;
+
+    /* Get both the chunk flags and chunk type data sets. */
+    sctd = otn->ds_list[PLUGIN_SCTP_CHUNK_TYPE];
+    scfd = otn->ds_list[PLUGIN_SCTP_CHUNK_FLAGS];
+
+    params = SnortStrdup(data);
+    while (isspace((u_char)*params)) params++;     /* nuke leading whitespace */
+    if (strlen(params) == 0)
+        FatalError("Error at %s:%d: Missing argument to the 'sctp_chunk_flags' "
+                   "keyword\n", file_name, file_line);
+
+    /* Parse each flag bit.  Loop once to validate, then again to parse. */
+    if (sctd->parse_count == 1)
+    {
+        end = params + strlen(params);
+
+        while ((params < end) && (comma_set == 0))
+        {
+            /* Parse operators or the '0' bit. */
+            switch (*params)
+            {
+            case '+':
+                scfd->mode = SCTP_FLAGS_ALL;
+                params++;
+                break;
+
+            case '*':
+                scfd->mode = SCTP_FLAGS_ANY;
+                params++;
+                break;
+
+            case '!':
+                scfd->mode = SCTP_FLAGS_NOT;
+                params++;
+                break;
+
+            case '0':
+                scfd->flags = 0;
+                params++;
+                continue;
+                break;
+
+            case ',':
+                comma_set = 1;
+                params++;
+                continue;
+                break;
+            }
+
+            /* Parse - Certain flag bits only work with certain chunk types. */
+            if (sctd->data)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('i', 'I', flags, DATA, I);
+                    SCTP_CHECK_CHUNK_FLAGS('u', 'U', flags, DATA, U);
+                    SCTP_CHECK_CHUNK_FLAGS('b', 'B', flags, DATA, B);
+                    SCTP_CHECK_CHUNK_FLAGS('e', 'E', flags, DATA, E);
+
+                default:
+                    FatalError("Error at %s:%d: Valid flags for DATA chunks "
+                               "are IUBE.\n", file_name, file_line);
+                    break;
+                }
+
+            else if (sctd->abort)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('t', 'T', flags, ABORT, T);
+
+                default:
+                    FatalError("Error at %s:%d: Valid flags for ABORT chunks "
+                               "are T.\n", file_name, file_line);
+                    break;
+                }
+
+            else if (sctd->shutdown_complete)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('t', 'T', flags, SHUTDOWN_COMPLETE, T);
+
+                default:
+                    FatalError("Error at %s:%d: Valid flags for "
+                               "SHUTDOWN_COMPLETE chunks are T.\n",
+                               file_name, file_line);
+                    break;
+                }
+
+            else if (sctd->pktdrop)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('c', 'C', flags, PKTDROP, C);
+                    SCTP_CHECK_CHUNK_FLAGS('t', 'T', flags, PKTDROP, T);
+                    SCTP_CHECK_CHUNK_FLAGS('b', 'B', flags, PKTDROP, B);
+                    SCTP_CHECK_CHUNK_FLAGS('m', 'M', flags, PKTDROP, M);
+
+                default:
+                    FatalError("Error at %s:%d: Valid flags for PKTDROP chunks "
+                               "are CTBM.\n", file_name, file_line);
+                    break;
+                }
+            else
+                FatalError("Error at %s:%d: The specified chunk type does not "
+                           "take any flags.\n", file_name, file_line);
+
+            params++;
+        }
+
+        /* Skip any whitespace between the <flags> and <mask> fields. */
+        while (isspace((u_char)*params)) params++;
+
+        /* Parse the mask field, if set. */
+        while ((params < end) && (comma_set == 1))
+        {
+            if (sctd->data)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('i', 'I', mask, DATA, I);
+                    SCTP_CHECK_CHUNK_FLAGS('u', 'U', mask, DATA, U);
+                    SCTP_CHECK_CHUNK_FLAGS('b', 'B', mask, DATA, B);
+                    SCTP_CHECK_CHUNK_FLAGS('e', 'E', mask, DATA, E);
+
+                default:
+                    FatalError("Error at %s:%d: Valid masks for DATA chunks "
+                               "are IUBE.\n", file_name, file_line);
+                    break;
+                }
+
+            else if (sctd->abort)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('t', 'T', mask, ABORT, T);
+
+                default:
+                    FatalError("Error at %s:%d: Valid masks for ABORT chunks "
+                               "are T.\n", file_name, file_line);
+                    break;
+                }
+
+            else if (sctd->shutdown_complete)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('t', 'T', mask, SHUTDOWN_COMPLETE, T);
+
+                default:
+                    FatalError("Error at %s:%d: Valid masks for "
+                               "SHUTDOWN_COMPLETE chunks are T.\n",
+                               file_name, file_line);
+                    break;
+                }
+
+            else if (sctd->pktdrop)
+                switch (*params)
+                {
+                    SCTP_CHECK_CHUNK_FLAGS('c', 'C', mask, PKTDROP, C);
+                    SCTP_CHECK_CHUNK_FLAGS('t', 'T', mask, PKTDROP, T);
+                    SCTP_CHECK_CHUNK_FLAGS('b', 'B', mask, PKTDROP, B);
+                    SCTP_CHECK_CHUNK_FLAGS('m', 'M', mask, PKTDROP, M);
+
+                default:
+                    FatalError("Error at %s:%d: Valid masks for PKTDROP chunks "
+                               "are CTBM.\n", file_name, file_line);
+                    break;
+                }
+            else
+                FatalError("Error at %s:%d: The specified chunk type does not "
+                           "take any masks.\n", file_name, file_line);
+
+            params++;
+        }
+    }
+    else
+        FatalError("Error at %s:%d: When using 'sctp_chunk_flags', the "
+                   "'sctp_chunk_type' keyword can only be set to a single "
+                   "parameter representing the chunk whose flags field "
+                   "you wish to check.\n",  file_name, file_line);
+}
+
+/**
+ * SctpChunkFlagsEval - Evaluation function for sctp_chunk_flags.
+ * @data: pointer to SctpChunkFlagsData (as char *).
+ * @p: pointer to Packet structure.
+ *
+ * Evaluates the rule option against the packet pointed to by 'p'.  Returns
+ * either DETECTION_OPTION_MATCH or DETECTION_OPTION_NO_MATCH.
+ */
+int SctpChunkFlagsEval(void *data, Packet *p)
+{
+    SctpChunkFlagsData *scfd = (SctpChunkFlagsData *)data;
+    int rval = DETECTION_OPTION_NO_MATCH;
+    PROFILE_VARS;
+
+    if(!p->sctph || !scfd)
+        return rval;
+
+    PREPROC_PROFILE_START(sctpChunkFlagsPerfStats);
+
+    SctpChunk *c = (SctpChunk *)p->sctph->chunks;
+    uint32_t remaining_len = p->dsize;
+
+    /*
+     * Loop through the chunks in the packet and for each chunk, check
+     * check the chunk flags against the supplied value for a match.
+     */
+    while ((c != NULL) &&
+           (remaining_len != 0) &&
+           (rval == DETECTION_OPTION_NO_MATCH))
+    {
+        uint8_t chunk_flags = c->flags & (0xff ^ scfd->mask);
+        uint16_t chunk_length = SCTP_ADD_PADDING(ntohs(c->length));
+        remaining_len -= chunk_length;
+        
+        /*
+         * Although we have already validated which chunks we want to check
+         * via 'sctp_chunk_type', we still have to check the flags for
+         * specific types because of chunk bundling.
+         */
+        switch (c->type)
+        {
+        case SCTP_DATA_C:
+        case SCTP_ABORT_C:
+        case SCTP_SHUTDOWN_COMPLETE_C:
+        case SCTP_PKTDROP_C:
+            switch (scfd->mode)
+            {
+            case SCTP_FLAGS_NORMAL:
+                if (scfd->flags == chunk_flags)
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+
+            case SCTP_FLAGS_ALL:
+                if ((scfd->flags & chunk_flags) == scfd->flags)
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+
+            case SCTP_FLAGS_ANY:
+                if ((scfd->flags & chunk_flags) != 0)
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+
+            case SCTP_FLAGS_NOT:
+                if ((scfd->flags & chunk_flags) == 0)
+                    rval = DETECTION_OPTION_MATCH;
+                break;
+            }
+            break;
+
+        case SCTP_INIT_C:
+        case SCTP_INIT_ACK_C:
+        case SCTP_SACK_C:
+        case SCTP_HEARTBEAT_C:
+        case SCTP_HEARTBEAT_ACK_C:
+        case SCTP_SHUTDOWN_C:
+        case SCTP_SHUTDOWN_ACK_C:
+        case SCTP_ERROR_C:
+        case SCTP_COOKIE_ECHO_C:
+        case SCTP_COOKIE_ACK_C:
+        case SCTP_ECNE_C:
+        case SCTP_CWR_C:
+        case SCTP_AUTH_C:
+        case SCTP_ASCONF_ACK_C:
+        case SCTP_PAD_C:
+        case SCTP_FORWARD_TSN_C:
+        case SCTP_ASCONF_C:
+            break;
+
+        default:
+            DEBUG_WRAP(DebugMessage(
+                DEBUG_PLUGIN, "Plugin (sctp_chunk_flags): Encountered "
+                              "unknown SCTP Chunk Type 0x%2x!\n", c->type));
+            break;
+        }
+
+        remaining_len = SctpGetNextChunk(c, remaining_len, chunk_length);
+    }
+
+    /* If the test isn't successful, return DETECTION_OPTION_NO_MATCH */
+    PREPROC_PROFILE_END(sctpChunkFlagsPerfStats);
+    return rval;
+}
diff --git a/src/detection-plugins/sp_sctp_chunk_flags.h b/src/detection-plugins/sp_sctp_chunk_flags.h
new file mode 100644
index 0000000..5de1493
--- /dev/null
+++ b/src/detection-plugins/sp_sctp_chunk_flags.h
@@ -0,0 +1,79 @@
+/*
+** Copyright (C) 2011 Joshua Kinard <kumba12345 () gmail com>
+**
+** This program is free software; you can redistribute it and/or modify
+** it under the terms of the GNU General Public License Version 2 as
+** published by the Free Software Foundation.  You may not use, modify or
+** distribute this program under any other version of the GNU General
+** Public License.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU General Public License for more details.
+**
+** You should have received a copy of the GNU General Public License
+** along with this program; if not, write to the Free Software
+** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+*/
+
+/* $Id$ */
+#ifndef __SP_SCTP_CHUNK_FLAGS_H__
+#define __SP_SCTP_CHUNK_FLAGS_H__
+
+/* From linux-kernel/include/linux/bitops.h */
+#define BIT(nr) (1UL << (nr))
+
+/* Flag Definitions for DATA. */
+#define SCTP_DATA_C_FLAGS_I                 BIT(3)  /* SACK Immediate */
+#define SCTP_DATA_C_FLAGS_U                 BIT(2)  /* Unordered */
+#define SCTP_DATA_C_FLAGS_B                 BIT(1)  /* Beginning Fragment */
+#define SCTP_DATA_C_FLAGS_E                 BIT(0)  /* Ending Fragment */
+#define SCTP_DATA_C_FLAGS_MASK              0xffff
+
+/* Flag Definitions for ABORT. */
+#define SCTP_ABORT_C_FLAGS_T                BIT(0)  /* VTag Reflected */
+#define SCTP_ABORT_C_FLAGS_MASK             0x0f
+
+/* Flag Definitions for SHUTDOWN-COMPLETE. */
+#define SCTP_SHUTDOWN_COMPLETE_C_FLAGS_T    BIT(0)  /* VTag Reflected */
+#define SCTP_SHUTDOWN_COMPLETE_C_FLAGS_MASK 0x0f
+
+/* Flag Definitions for PKTDROP. */
+#define SCTP_PKTDROP_C_FLAGS_C              BIT(3)  /* Count Transform */
+#define SCTP_PKTDROP_C_FLAGS_T              BIT(2)  /* Truncated */
+#define SCTP_PKTDROP_C_FLAGS_B              BIT(1)  /* Bad CRC32c */
+#define SCTP_PKTDROP_C_FLAGS_M              BIT(0)  /* Middle/VTag Reflected */
+#define SCTP_PKTDROP_C_FLAGS_MASK           0xffff
+
+/* Flag Mode Definitions. */
+#define SCTP_FLAGS_NORMAL                   0x00
+#define SCTP_FLAGS_ALL                      0x01
+#define SCTP_FLAGS_ANY                      0x02
+#define SCTP_FLAGS_NOT                      0x04
+
+/* Macros to duplicate common bits of code and make things look cleaner. */
+#define SCTP_CHECK_CHUNK_FLAGS(lower,upper,field,chunk,bit)            \
+                case lower:                                            \
+                case upper:                                            \
+                    scfd->field |= SCTP_##chunk##_C_FLAGS_##bit;       \
+                    break
+
+
+/* SctpChunkFlags data structure. */
+typedef struct _SctpChunkFlagsData
+{
+    u_char mode;
+    u_char flags;
+    u_char mask;
+} SctpChunkFlagsData;
+
+/* Prototypes. */
+uint32_t SctpChunkFlagsHash(void *data);
+int SctpChunkFlagsCompare(void *l, void *r);
+void SctpChunkFlagsSetup(void);
+void SctpChunkFlagsInit(char *data, OptTreeNode *otn, int protocol);
+void SctpChunkFlagsParse(char *data, OptTreeNode *otn);
+int SctpChunkFlagsEval(void *data, Packet *p);
+
+#endif  /* __SP_SCTP_CHUNK_FLAGS_H__ */
